糖逗 发表于 2020-4-6 12:36:12

C++刷剑指offer(面试题12. 矩阵中的路径)【回溯算法】

题目描述:
请设计一个函数,用来判断在一个矩阵中是否存在一条包含某字符串所有字符的路径。路径可以从矩阵中的任意一格开始,每一步可以在矩阵中向左、右、上、下移动一格。如果一条路径经过了矩阵的某一格,那么该路径不能再次进入该格子。例如,在下面的3×4的矩阵中包含一条字符串“bfce”的路径(路径中的字母用加粗标出)。

[["a","b","c","e"],
["s","f","c","s"],
["a","d","e","e"]]

但矩阵中不包含字符串“abfb”的路径,因为字符串的第一个字符b占据了矩阵中的第一行第二个格子之后,路径不能再次进入这个格子。

 

示例 1:

输入:board = [["A","B","C","E"],["S","F","C","S"],["A","D","E","E"]], word = "ABCCED"
输出:true
示例 2:

输入:board = [["a","b"],["c","d"]], word = "abcd"
输出:false
提示:

1 <= board.length <= 200
1 <= board.length <= 200

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/ju-zhen-zhong-de-lu-jing-lcof
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。



#include <vector>
#include <iostream>
#include <string>

using namespace std;

bool dfs(vector<vector<char>>& board, string& word, int i,int j,int length){
    if(i >= board.size() || j >= board.size() || i<0 || j<0 || length >= word.size()|| word!=board){
      return false;
    }
    if(length == word.size()-1 && word == board){
      return true;
    }
    char temp = board;
    board = '0';
    bool flag = dfs(board,word,i,j+1,length+1)||dfs(board,word,i,j-1,length+1)||dfs(board,word,i+1,j,length+1)||dfs(board,word,i-1,j,length+1);
    board = temp;
    return flag;
}
   
bool solution(vector<vector<char> >& input, string target){
        for(int i = 0; i < input.size(); i++){
                for(int j = 0; j < input.size(); j++){
                        if(dfs(input, target, i, j, 0)){
                                return true;
                        }
                }
               
        }
        return false;
}



int main(void){
        int row, col;
        cout << "send row for the matrix" << endl;
        cin >> row;
        cin.clear();
        cout << "send column for the matrix" << endl;
        cin >> col;
        cin.clear();
        cout << "send the element for the matrix" << endl;
        vector<vector<char> > input;
        input.resize(row);
        char a;
        for(int i = 0; i < row; i++){
                for(int j = 0; j < col; j++){
                        cin >> a;
                        input.push_back(a);
                }
        }
        cin.clear();
        cout << "print the matrix" << endl;
        for(int i = 0; i < row; i++){
      for(int j = 0; j < col; j++){
            cout << input << " ";
      }
      cout << endl;
        }
       
        cout << "send the target" << endl;
        string target;
        cin >> target;

       
        bool res = solution(input, target);
        cout << res << endl;
        return 0;
}


注意事项:
1.参考链接:https://leetcode-cn.com/problems/ju-zhen-zhong-de-lu-jing-lcof/solution/shen-du-you-xian-sou-suo-by-z1m/
2.目标查找的字符串的第一个字符可以出现在matrix中的任意一个位置,因此用了两层for循环暴力搜索。
3.在两层for循环中使用回溯算法,回溯算法包括:剪枝、递归。
4.已经访问到的字符标记为0,否则没有找到后回溯将这个字符由0变为原来的字符。

糖逗 发表于 2020-4-6 12:51:49

这道题做的不好,还需要再做一遍。{:10_284:}
页: [1]
查看完整版本: C++刷剑指offer(面试题12. 矩阵中的路径)【回溯算法】